#!/bin/bash

#gcc
#nvhpc/24.7-gcc-11.2.0 
#export LD_LIBRARY_PATH

ulimit -s unlimited

set -e

# set DEVICE:
source conf.sh

export VERBOSE_LEVEL=2
        
if [ "$1" == 'gpu' ]
then
    #rm -rf build_gpu
    cmake -B build_gpu -S . -DMU_ARCH=$DEVICE -DCMAKE_CXX_FLAGS="-O0 -g"
    cmake --build build_gpu --parallel 

    ncells=(8)
    nlev=(3)
    nproma=(2) # more than one block to check correctness
else 
    #rm -rf build
    cmake -B build -S . -DMU_ARCH=x86_64 -DCMAKE_CXX_FLAGS="-O0 -g"
    cmake --build build --parallel

    ncells=(8)
    nlev=(3)   
    nproma=(2) #(32 64 96 128)

    export OMP_PROC_BIND=close
    export OMP_PLACES=cores
    export OMP_NUM_THREADS=1
fi

for jb in ${ncells[*]}; do 
    for jk in ${nlev[*]}; do
        for jc in ${nproma[*]}; do
            export NPROMA=$jc
            export NLEV=$jk
            export NCELLS=$jb
            if [ "$1" == 'gpu' ] 
            then
                #./build_gpu/demo
                ./build_gpu/fdemo
            else
                #./build/demo
                ./build/fdemo
            fi
            echo "---"
        done
    done
done
