#!/bin/bash

#gcc
#nvhpc/24.7-gcc-11.2.0 
#export LD_LIBRARY_PATH


ulimit -s unlimited

set -e

# set DEVICE:
source conf.sh

export VERBOSE_LEVEL=2

if [ "$1" == 'gpu' ]
then
    #rm -rf build_gpu
    cmake -B build_gpu -S . -DMU_ARCH=$DEVICE -DCMAKE_CXX_FLAGS="-O3"
    cmake --build build_gpu --parallel 

    ncells=(5000064)
    nlev=(90)
    nproma=(5000064)
    #nproma=$((449*29))
else 
    #rm -rf build
    cmake -B build -S . -DMU_ARCH=x86_64 -DCMAKE_CXX_FLAGS="-O3" -DCMAKE_Fortran_FLAGS="-O3 -fopenmp"
    cmake --build build --parallel

    ncells=(5000064)
    nlev=(90)   
    nproma=(32 64 96 128)

    export OMP_PROC_BIND=close
    export OMP_PLACES=cores
    export OMP_NUM_THREADS=8
    echo "OMP_NUM_THREADS=${OMP_NUM_THREADS}"
fi

for jb in ${ncells[*]}; do 
    for jk in ${nlev[*]}; do
        for jc in ${nproma[*]}; do
            export NPROMA=$jc
            export NLEV=$jk
            export NCELLS=$jb
            if [ "$1" == 'gpu' ] 
            then
                #./build_gpu/demo
                ./build_gpu/fdemo 
            else
                #./build/demo
                ./build/fdemo
                echo "--------------------------------------------------------"
            fi
        done
    done
done
